﻿Public Class fMain

    Private FileName As String
    Private MainControls As Collection

    Private Sub fMain_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load

        Dim C As Control
        Dim i As Integer

        mnuFileSave.Enabled = False
        mnuFileSaveAs.Enabled = False
        mnuFileClose.Enabled = False
        cboFileInfo.Enabled = False

        With cboFileInfo
            .Items.Add("Caption")
            .Items.Add("Keywords")
            .Items.Add("Categories")
            .Items.Add("Credits")
            .Items.Add("Origin")
            .Items.Add("Copyright & URL")
            .Items.Add("Creator Contact")
            .Items.Add("EXIF Data")
            .Text = "No image loaded"
        End With

        MainControls = New Collection()
        With MainControls
            .Add(grpCaption)
            .Add(grpKeywords)
            .Add(grpCategories)
            .Add(grpCredits)
            .Add(grpOrigin)
            .Add(grpCopyright)
            .Add(grpContact)
            .Add(grpExif)
            .Add(cmdApply)
        End With

        For Each C In MainControls
            C.Visible = False
        Next

        With cboUrgency
            For i = 1 To 8
                .Items.Add(Str(i))
            Next
            .Items.Add("None")
            .Text = "None"
        End With

        AxImageBox1.AutoZoom = True
    End Sub

    Private Sub mnuFileOpen_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles mnuFileOpen.Click

        With dlgOpen
            .Title = "Load JPEG or TIFF File"
            .Filter = "JPEG Files (*.jpg, *.jpeg, *.jpe)|*.jpg;*.jpeg;*.jpe|TIFF Files (*.tif, *.tiff)|*.tif;*.tiff"
            If .ShowDialog() <> Windows.Forms.DialogResult.Cancel Then
                FileName = .FileName
                AxImageBox1.LoadFromFile(FileName)
                mnuFileSave.Enabled = True
                mnuFileSaveAs.Enabled = True
                mnuFileClose.Enabled = True
                cboFileInfo.Enabled = True
                cboFileInfo.Text = "Caption"
                UpdateDisplay()

                ReadFileInfo()
            End If
        End With
    End Sub

    Private Sub UpdateDisplay()

        Dim C As Control

        For Each C In MainControls
            C.Visible = False
        Next

        If AxImageBox1.ImageLoaded Then
            Select Case cboFileInfo.Text
                Case "Caption"
                    grpCaption.Visible = True
                Case "Keywords"
                    grpKeywords.Visible = True
                Case "Categories"
                    grpCategories.Visible = True
                Case "Credits"
                    grpCredits.Visible = True
                Case "Origin"
                    grpOrigin.Visible = True
                Case "Copyright & URL"
                    grpCopyright.Visible = True
                Case "Creator Contact"
                    grpContact.Visible = True
                Case "EXIF Data"
                    grpExif.Visible = True
            End Select
            cmdApply.Visible = True
        End If

    End Sub

    Private Sub cboFileInfo_SelectedIndexChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles cboFileInfo.SelectedIndexChanged

        UpdateDisplay()

    End Sub

    Private Sub cmdAddKeyword_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles cmdAddKeyword.Click

        If txtKeywordAdd.Text <> "" Then
            lstKeywords.Items.Add(txtKeywordAdd.Text)
            txtKeywordAdd.Text = ""
        End If

    End Sub

    Private Sub cmdAddSupCat_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles cmdAddSupCat.Click

        If txtSupCatAdd.Text <> "" Then
            lstSupCats.Items.Add(txtSupCatAdd.Text)
            txtSupCatAdd.Text = ""
        End If

    End Sub

    Private Sub cmdApply_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles cmdApply.Click

        WriteFileInfo()

    End Sub

    Private Sub cmdDelKeyword_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles cmdDelKeyword.Click

        Dim i As Integer

        i = lstKeywords.SelectedIndex
        If i <> -1 Then
            lstKeywords.Items.RemoveAt(i)
        End If

    End Sub

    Private Sub cmdDelSupCat_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles cmdDelSupCat.Click

        Dim i As Integer

        i = lstSupCats.SelectedIndex
        If i <> -1 Then
            lstSupCats.Items.RemoveAt(i)
        End If

    End Sub

    Private Sub cmdExifAdd_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles cmdExifAdd.Click

        Dim AddForm As fAdd

        AddForm = New fAdd()
        AddForm.ShowDialog()
        AddForm = Nothing

        If Not AxImageBox1.ExifSetAttribute(ExifAttName, ExifAttVal) Then
            MsgBox("Invalid Exif Attribute Specification")
        End If

        ExifUpdate()

    End Sub

    Private Sub cmdExifDelete_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles cmdExifDelete.Click

        Dim DelForm As fDel

        DelForm = New fDel()
        DelForm.ShowDialog()
        DelForm = Nothing

        If Not AxImageBox1.ExifDelete(ExifAttName) Then
            MsgBox("Invalid Exif Attribute Specification")
        End If

        ExifUpdate()

    End Sub

    Private Sub ExifUpdate()

        Dim i As Integer

        lstExif.Items.Clear()
        For i = 0 To AxImageBox1.ExifCount - 1
            lstExif.Items.Add(AxImageBox1.get_ExifName(i) & ":  " & AxImageBox1.get_ExifValueByIndex(i))
        Next i

    End Sub

    Private Sub cmdToday_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles cmdToday.Click

        txtDate.Text = Format(Now, "Short Date")

    End Sub

    Private Sub mnuFileSave_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles mnuFileSave.Click

        On Error GoTo ErrorHandler

        AxImageBox1.SaveToFile(FileName)

        Exit Sub

ErrorHandler:

        MsgBox(Err.Description, vbCritical, "Error")

        Exit Sub

    End Sub

    Private Sub mnuFileSaveAs_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles mnuFileSaveAs.Click

        On Error GoTo ErrorHandler

        With dlgSave
            .Title = "Save As"
            .Filter = "JPEG Files (*.jpg)|*.jpg|TIFF Files (*.tif)|*.tif"
            .FileName = ""
            If .ShowDialog() <> Windows.Forms.DialogResult.Cancel Then
                FileName = .FileName
                AxImageBox1.SaveToFile(FileName)
            End If
        End With
        Exit Sub

ErrorHandler:

        MsgBox(Err.Description, vbCritical, "Error")

        Exit Sub

    End Sub

    Private Sub mnuFileClose_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles mnuFileClose.Click

        AxImageBox1.Clear()
        FileName = ""
        mnuFileSave.Enabled = False
        mnuFileSaveAs.Enabled = False
        mnuFileClose.Enabled = False
        cboFileInfo.Enabled = False
        cboFileInfo.Text = "No Image Loaded"
        UpdateDisplay()

    End Sub

    Private Sub mnuFileExit_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles mnuFileExit.Click

        Me.Close()

    End Sub

    Private Sub mnuHelpAbout_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles mnuHelpAbout.Click

        AxImageBox1.AboutBox()

    End Sub

    Private Sub ReadFileInfo()

        Dim i As Integer

        With AxImageBox1
            If .ImageLoaded Then
                ' Caption
                txtCaption.Text = .FFO_Caption
                txtCaptionWriter.Text = .FFO_CaptionWriter
                txtHeadline.Text = .FFO_Headline
                txtSpecInst.Text = .FFO_SpecialInstructions

                ' Keywords
                lstKeywords.Items.Clear()
                For i = 0 To .FFO_KeywordsCount - 1
                    lstKeywords.Items.Add(.get_FFO_Keywords(i))
                Next i

                ' Categories
                txtCategory.Text = .FFO_Category
                lstSupCats.Items.Clear()
                For i = 0 To .FFO_SuppCatCount - 1
                    lstSupCats.Items.Add(.get_FFO_SuppCat(i))
                Next i
                If .FFO_Urgency <> 0 Then
                    cboUrgency.Text = Str(.FFO_Urgency)
                Else
                    cboUrgency.Text = "None"
                End If

                ' Credits
                txtByline.Text = .FFO_Byline
                txtBylineTitle.Text = .FFO_BylineTitle
                txtCredit.Text = .FFO_Credit
                txtSource.Text = .FFO_Source

                ' Origin
                txtObjectName.Text = .FFO_ObjectName
                txtDate.Text = Format(.FFO_DateCreated, "Short Date")
                txtCity.Text = .FFO_City
                txtProvince.Text = .FFO_ProvinceState
                txtCountry.Text = .FFO_CountryName
                txtOTR.Text = .FFO_OTR

                ' Copyright & URL
                If .FFO_CopyrightFlag Then
                    chkIsCopyright.Checked = True
                Else
                    chkIsCopyright.Checked = False
                End If
                txtCopyright.Text = .FFO_CopyrightNotice
                txtImageURL.Text = .FFO_ImageURL

                ' Creator Contact
                txtCreator.Text = .FFO_Author
                txtAddress.Text = .FFO_CiAdrExtAdr
                txtCity2.Text = .FFO_CiAdrCity
                txtRegion.Text = .FFO_CiAdrRegion
                txtPostCode.Text = .FFO_CiAdrPcode
                txtCountry2.Text = .FFO_CiAdrCtry

                ' Exif Data
                lstExif.Items.Clear()
                For i = 0 To .ExifCount - 1
                    lstExif.Items.Add(.get_ExifName(i) & ":  " & .get_ExifValueByIndex(i))
                Next i
            End If
        End With

    End Sub

    Private Sub WriteFileInfo()

        Dim i As Integer

        With AxImageBox1
            If .ImageLoaded Then
                ' Caption
                .FFO_Caption = txtCaption.Text
                .FFO_CaptionWriter = txtCaptionWriter.Text
                .FFO_Headline = txtHeadline.Text
                .FFO_SpecialInstructions = txtSpecInst.Text

                ' Keywords
                .FFO_KeywordsClear()
                For i = 0 To lstKeywords.Items.Count - 1
                    .FFO_KeywordsAdd(lstKeywords.Items(i))
                Next i

                ' Categories
                .FFO_Category = txtCategory.Text
                .FFO_SuppCatClear()
                For i = 0 To lstSupCats.Items.Count - 1
                    .FFO_SuppCatAdd(lstSupCats.Items(i))
                Next i
                If cboUrgency.Text <> "None" Then
                    .FFO_Urgency = Val(cboUrgency.Text)
                Else
                    .FFO_Urgency = 0
                End If

                ' Credits
                .FFO_Byline = txtByline.Text
                .FFO_BylineTitle = txtBylineTitle.Text
                .FFO_Credit = txtCredit.Text
                .FFO_Source = txtSource.Text

                ' Origin
                .FFO_ObjectName = txtObjectName.Text
                .FFO_DateCreated = DateValue(txtDate.Text)
                .FFO_City = txtCity.Text
                .FFO_ProvinceState = txtProvince.Text
                .FFO_CountryName = txtCountry.Text
                .FFO_OTR = txtOTR.Text

                ' Copyright & URL
                If chkIsCopyright.Checked Then
                    .FFO_CopyrightFlag = True
                Else
                    .FFO_CopyrightFlag = False
                End If
                .FFO_CopyrightNotice = txtCopyright.Text
                .FFO_ImageURL = txtImageURL.Text

                ' Creator Contact
                .FFO_Author = txtCreator.Text
                .FFO_CiAdrExtAdr = txtAddress.Text
                .FFO_CiAdrCity = txtCity2.Text
                .FFO_CiAdrRegion = txtRegion.Text
                .FFO_CiAdrPcode = txtPostCode.Text
                .FFO_CiAdrCtry = txtCountry2.Text

            End If
        End With

    End Sub

End Class
